// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: resourcemodule/resourcemodule.proto

package openfmb.resourcemodule;

/**
 * <pre>
 * LN: Generic process I/O   Name: GGIO
 * </pre>
 *
 * Protobuf type {@code resourcemodule.BooleanControlGGIO}
 */
public final class BooleanControlGGIO extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:resourcemodule.BooleanControlGGIO)
    BooleanControlGGIOOrBuilder {
private static final long serialVersionUID = 0L;
  // Use BooleanControlGGIO.newBuilder() to construct.
  private BooleanControlGGIO(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private BooleanControlGGIO() {
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(
      UnusedPrivateParameter unused) {
    return new BooleanControlGGIO();
  }

  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return openfmb.resourcemodule.Resourcemodule.internal_static_resourcemodule_BooleanControlGGIO_descriptor;
  }

  @java.lang.Override
  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return openfmb.resourcemodule.Resourcemodule.internal_static_resourcemodule_BooleanControlGGIO_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            openfmb.resourcemodule.BooleanControlGGIO.class, openfmb.resourcemodule.BooleanControlGGIO.Builder.class);
  }

  public static final int LOGICALNODE_FIELD_NUMBER = 1;
  private openfmb.commonmodule.LogicalNode logicalNode_;
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.LogicalNode logicalNode = 1 [(.uml.option_parent_message) = true];</code>
   * @return Whether the logicalNode field is set.
   */
  @java.lang.Override
  public boolean hasLogicalNode() {
    return logicalNode_ != null;
  }
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.LogicalNode logicalNode = 1 [(.uml.option_parent_message) = true];</code>
   * @return The logicalNode.
   */
  @java.lang.Override
  public openfmb.commonmodule.LogicalNode getLogicalNode() {
    return logicalNode_ == null ? openfmb.commonmodule.LogicalNode.getDefaultInstance() : logicalNode_;
  }
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.LogicalNode logicalNode = 1 [(.uml.option_parent_message) = true];</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.LogicalNodeOrBuilder getLogicalNodeOrBuilder() {
    return logicalNode_ == null ? openfmb.commonmodule.LogicalNode.getDefaultInstance() : logicalNode_;
  }

  public static final int PHASE_FIELD_NUMBER = 2;
  private openfmb.commonmodule.Optional_PhaseCodeKind phase_;
  /**
   * <pre>
   * Phase code
   * </pre>
   *
   * <code>.commonmodule.Optional_PhaseCodeKind Phase = 2;</code>
   * @return Whether the phase field is set.
   */
  @java.lang.Override
  public boolean hasPhase() {
    return phase_ != null;
  }
  /**
   * <pre>
   * Phase code
   * </pre>
   *
   * <code>.commonmodule.Optional_PhaseCodeKind Phase = 2;</code>
   * @return The phase.
   */
  @java.lang.Override
  public openfmb.commonmodule.Optional_PhaseCodeKind getPhase() {
    return phase_ == null ? openfmb.commonmodule.Optional_PhaseCodeKind.getDefaultInstance() : phase_;
  }
  /**
   * <pre>
   * Phase code
   * </pre>
   *
   * <code>.commonmodule.Optional_PhaseCodeKind Phase = 2;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.Optional_PhaseCodeKindOrBuilder getPhaseOrBuilder() {
    return phase_ == null ? openfmb.commonmodule.Optional_PhaseCodeKind.getDefaultInstance() : phase_;
  }

  public static final int SPCSO_FIELD_NUMBER = 3;
  private openfmb.commonmodule.ControlSPC sPCSO_;
  /**
   * <pre>
   * (controllable) If true, generic single point controllable status output &lt;i&gt;n&lt;/i&gt; has been
   * enabled, otherwise it has been disabled.
   * </pre>
   *
   * <code>.commonmodule.ControlSPC SPCSO = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return Whether the sPCSO field is set.
   */
  @java.lang.Override
  public boolean hasSPCSO() {
    return sPCSO_ != null;
  }
  /**
   * <pre>
   * (controllable) If true, generic single point controllable status output &lt;i&gt;n&lt;/i&gt; has been
   * enabled, otherwise it has been disabled.
   * </pre>
   *
   * <code>.commonmodule.ControlSPC SPCSO = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return The sPCSO.
   */
  @java.lang.Override
  public openfmb.commonmodule.ControlSPC getSPCSO() {
    return sPCSO_ == null ? openfmb.commonmodule.ControlSPC.getDefaultInstance() : sPCSO_;
  }
  /**
   * <pre>
   * (controllable) If true, generic single point controllable status output &lt;i&gt;n&lt;/i&gt; has been
   * enabled, otherwise it has been disabled.
   * </pre>
   *
   * <code>.commonmodule.ControlSPC SPCSO = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.ControlSPCOrBuilder getSPCSOOrBuilder() {
    return sPCSO_ == null ? openfmb.commonmodule.ControlSPC.getDefaultInstance() : sPCSO_;
  }

  private byte memoizedIsInitialized = -1;
  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (logicalNode_ != null) {
      output.writeMessage(1, getLogicalNode());
    }
    if (phase_ != null) {
      output.writeMessage(2, getPhase());
    }
    if (sPCSO_ != null) {
      output.writeMessage(3, getSPCSO());
    }
    getUnknownFields().writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (logicalNode_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(1, getLogicalNode());
    }
    if (phase_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(2, getPhase());
    }
    if (sPCSO_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(3, getSPCSO());
    }
    size += getUnknownFields().getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof openfmb.resourcemodule.BooleanControlGGIO)) {
      return super.equals(obj);
    }
    openfmb.resourcemodule.BooleanControlGGIO other = (openfmb.resourcemodule.BooleanControlGGIO) obj;

    if (hasLogicalNode() != other.hasLogicalNode()) return false;
    if (hasLogicalNode()) {
      if (!getLogicalNode()
          .equals(other.getLogicalNode())) return false;
    }
    if (hasPhase() != other.hasPhase()) return false;
    if (hasPhase()) {
      if (!getPhase()
          .equals(other.getPhase())) return false;
    }
    if (hasSPCSO() != other.hasSPCSO()) return false;
    if (hasSPCSO()) {
      if (!getSPCSO()
          .equals(other.getSPCSO())) return false;
    }
    if (!getUnknownFields().equals(other.getUnknownFields())) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (hasLogicalNode()) {
      hash = (37 * hash) + LOGICALNODE_FIELD_NUMBER;
      hash = (53 * hash) + getLogicalNode().hashCode();
    }
    if (hasPhase()) {
      hash = (37 * hash) + PHASE_FIELD_NUMBER;
      hash = (53 * hash) + getPhase().hashCode();
    }
    if (hasSPCSO()) {
      hash = (37 * hash) + SPCSO_FIELD_NUMBER;
      hash = (53 * hash) + getSPCSO().hashCode();
    }
    hash = (29 * hash) + getUnknownFields().hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static openfmb.resourcemodule.BooleanControlGGIO parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.resourcemodule.BooleanControlGGIO parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.resourcemodule.BooleanControlGGIO parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.resourcemodule.BooleanControlGGIO parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.resourcemodule.BooleanControlGGIO parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.resourcemodule.BooleanControlGGIO parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.resourcemodule.BooleanControlGGIO parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.resourcemodule.BooleanControlGGIO parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.resourcemodule.BooleanControlGGIO parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static openfmb.resourcemodule.BooleanControlGGIO parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.resourcemodule.BooleanControlGGIO parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.resourcemodule.BooleanControlGGIO parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(openfmb.resourcemodule.BooleanControlGGIO prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * <pre>
   * LN: Generic process I/O   Name: GGIO
   * </pre>
   *
   * Protobuf type {@code resourcemodule.BooleanControlGGIO}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:resourcemodule.BooleanControlGGIO)
      openfmb.resourcemodule.BooleanControlGGIOOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return openfmb.resourcemodule.Resourcemodule.internal_static_resourcemodule_BooleanControlGGIO_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return openfmb.resourcemodule.Resourcemodule.internal_static_resourcemodule_BooleanControlGGIO_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              openfmb.resourcemodule.BooleanControlGGIO.class, openfmb.resourcemodule.BooleanControlGGIO.Builder.class);
    }

    // Construct using openfmb.resourcemodule.BooleanControlGGIO.newBuilder()
    private Builder() {

    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);

    }
    @java.lang.Override
    public Builder clear() {
      super.clear();
      bitField0_ = 0;
      logicalNode_ = null;
      if (logicalNodeBuilder_ != null) {
        logicalNodeBuilder_.dispose();
        logicalNodeBuilder_ = null;
      }
      phase_ = null;
      if (phaseBuilder_ != null) {
        phaseBuilder_.dispose();
        phaseBuilder_ = null;
      }
      sPCSO_ = null;
      if (sPCSOBuilder_ != null) {
        sPCSOBuilder_.dispose();
        sPCSOBuilder_ = null;
      }
      return this;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return openfmb.resourcemodule.Resourcemodule.internal_static_resourcemodule_BooleanControlGGIO_descriptor;
    }

    @java.lang.Override
    public openfmb.resourcemodule.BooleanControlGGIO getDefaultInstanceForType() {
      return openfmb.resourcemodule.BooleanControlGGIO.getDefaultInstance();
    }

    @java.lang.Override
    public openfmb.resourcemodule.BooleanControlGGIO build() {
      openfmb.resourcemodule.BooleanControlGGIO result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public openfmb.resourcemodule.BooleanControlGGIO buildPartial() {
      openfmb.resourcemodule.BooleanControlGGIO result = new openfmb.resourcemodule.BooleanControlGGIO(this);
      if (bitField0_ != 0) { buildPartial0(result); }
      onBuilt();
      return result;
    }

    private void buildPartial0(openfmb.resourcemodule.BooleanControlGGIO result) {
      int from_bitField0_ = bitField0_;
      if (((from_bitField0_ & 0x00000001) != 0)) {
        result.logicalNode_ = logicalNodeBuilder_ == null
            ? logicalNode_
            : logicalNodeBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000002) != 0)) {
        result.phase_ = phaseBuilder_ == null
            ? phase_
            : phaseBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000004) != 0)) {
        result.sPCSO_ = sPCSOBuilder_ == null
            ? sPCSO_
            : sPCSOBuilder_.build();
      }
    }

    @java.lang.Override
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof openfmb.resourcemodule.BooleanControlGGIO) {
        return mergeFrom((openfmb.resourcemodule.BooleanControlGGIO)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(openfmb.resourcemodule.BooleanControlGGIO other) {
      if (other == openfmb.resourcemodule.BooleanControlGGIO.getDefaultInstance()) return this;
      if (other.hasLogicalNode()) {
        mergeLogicalNode(other.getLogicalNode());
      }
      if (other.hasPhase()) {
        mergePhase(other.getPhase());
      }
      if (other.hasSPCSO()) {
        mergeSPCSO(other.getSPCSO());
      }
      this.mergeUnknownFields(other.getUnknownFields());
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              input.readMessage(
                  getLogicalNodeFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000001;
              break;
            } // case 10
            case 18: {
              input.readMessage(
                  getPhaseFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000002;
              break;
            } // case 18
            case 26: {
              input.readMessage(
                  getSPCSOFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000004;
              break;
            } // case 26
            default: {
              if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                done = true; // was an endgroup tag
              }
              break;
            } // default:
          } // switch (tag)
        } // while (!done)
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.unwrapIOException();
      } finally {
        onChanged();
      } // finally
      return this;
    }
    private int bitField0_;

    private openfmb.commonmodule.LogicalNode logicalNode_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.LogicalNode, openfmb.commonmodule.LogicalNode.Builder, openfmb.commonmodule.LogicalNodeOrBuilder> logicalNodeBuilder_;
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNode logicalNode = 1 [(.uml.option_parent_message) = true];</code>
     * @return Whether the logicalNode field is set.
     */
    public boolean hasLogicalNode() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNode logicalNode = 1 [(.uml.option_parent_message) = true];</code>
     * @return The logicalNode.
     */
    public openfmb.commonmodule.LogicalNode getLogicalNode() {
      if (logicalNodeBuilder_ == null) {
        return logicalNode_ == null ? openfmb.commonmodule.LogicalNode.getDefaultInstance() : logicalNode_;
      } else {
        return logicalNodeBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNode logicalNode = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder setLogicalNode(openfmb.commonmodule.LogicalNode value) {
      if (logicalNodeBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        logicalNode_ = value;
      } else {
        logicalNodeBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNode logicalNode = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder setLogicalNode(
        openfmb.commonmodule.LogicalNode.Builder builderForValue) {
      if (logicalNodeBuilder_ == null) {
        logicalNode_ = builderForValue.build();
      } else {
        logicalNodeBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNode logicalNode = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder mergeLogicalNode(openfmb.commonmodule.LogicalNode value) {
      if (logicalNodeBuilder_ == null) {
        if (((bitField0_ & 0x00000001) != 0) &&
          logicalNode_ != null &&
          logicalNode_ != openfmb.commonmodule.LogicalNode.getDefaultInstance()) {
          getLogicalNodeBuilder().mergeFrom(value);
        } else {
          logicalNode_ = value;
        }
      } else {
        logicalNodeBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNode logicalNode = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder clearLogicalNode() {
      bitField0_ = (bitField0_ & ~0x00000001);
      logicalNode_ = null;
      if (logicalNodeBuilder_ != null) {
        logicalNodeBuilder_.dispose();
        logicalNodeBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNode logicalNode = 1 [(.uml.option_parent_message) = true];</code>
     */
    public openfmb.commonmodule.LogicalNode.Builder getLogicalNodeBuilder() {
      bitField0_ |= 0x00000001;
      onChanged();
      return getLogicalNodeFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNode logicalNode = 1 [(.uml.option_parent_message) = true];</code>
     */
    public openfmb.commonmodule.LogicalNodeOrBuilder getLogicalNodeOrBuilder() {
      if (logicalNodeBuilder_ != null) {
        return logicalNodeBuilder_.getMessageOrBuilder();
      } else {
        return logicalNode_ == null ?
            openfmb.commonmodule.LogicalNode.getDefaultInstance() : logicalNode_;
      }
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNode logicalNode = 1 [(.uml.option_parent_message) = true];</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.LogicalNode, openfmb.commonmodule.LogicalNode.Builder, openfmb.commonmodule.LogicalNodeOrBuilder> 
        getLogicalNodeFieldBuilder() {
      if (logicalNodeBuilder_ == null) {
        logicalNodeBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.LogicalNode, openfmb.commonmodule.LogicalNode.Builder, openfmb.commonmodule.LogicalNodeOrBuilder>(
                getLogicalNode(),
                getParentForChildren(),
                isClean());
        logicalNode_ = null;
      }
      return logicalNodeBuilder_;
    }

    private openfmb.commonmodule.Optional_PhaseCodeKind phase_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.Optional_PhaseCodeKind, openfmb.commonmodule.Optional_PhaseCodeKind.Builder, openfmb.commonmodule.Optional_PhaseCodeKindOrBuilder> phaseBuilder_;
    /**
     * <pre>
     * Phase code
     * </pre>
     *
     * <code>.commonmodule.Optional_PhaseCodeKind Phase = 2;</code>
     * @return Whether the phase field is set.
     */
    public boolean hasPhase() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     * <pre>
     * Phase code
     * </pre>
     *
     * <code>.commonmodule.Optional_PhaseCodeKind Phase = 2;</code>
     * @return The phase.
     */
    public openfmb.commonmodule.Optional_PhaseCodeKind getPhase() {
      if (phaseBuilder_ == null) {
        return phase_ == null ? openfmb.commonmodule.Optional_PhaseCodeKind.getDefaultInstance() : phase_;
      } else {
        return phaseBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * Phase code
     * </pre>
     *
     * <code>.commonmodule.Optional_PhaseCodeKind Phase = 2;</code>
     */
    public Builder setPhase(openfmb.commonmodule.Optional_PhaseCodeKind value) {
      if (phaseBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        phase_ = value;
      } else {
        phaseBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Phase code
     * </pre>
     *
     * <code>.commonmodule.Optional_PhaseCodeKind Phase = 2;</code>
     */
    public Builder setPhase(
        openfmb.commonmodule.Optional_PhaseCodeKind.Builder builderForValue) {
      if (phaseBuilder_ == null) {
        phase_ = builderForValue.build();
      } else {
        phaseBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Phase code
     * </pre>
     *
     * <code>.commonmodule.Optional_PhaseCodeKind Phase = 2;</code>
     */
    public Builder mergePhase(openfmb.commonmodule.Optional_PhaseCodeKind value) {
      if (phaseBuilder_ == null) {
        if (((bitField0_ & 0x00000002) != 0) &&
          phase_ != null &&
          phase_ != openfmb.commonmodule.Optional_PhaseCodeKind.getDefaultInstance()) {
          getPhaseBuilder().mergeFrom(value);
        } else {
          phase_ = value;
        }
      } else {
        phaseBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Phase code
     * </pre>
     *
     * <code>.commonmodule.Optional_PhaseCodeKind Phase = 2;</code>
     */
    public Builder clearPhase() {
      bitField0_ = (bitField0_ & ~0x00000002);
      phase_ = null;
      if (phaseBuilder_ != null) {
        phaseBuilder_.dispose();
        phaseBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Phase code
     * </pre>
     *
     * <code>.commonmodule.Optional_PhaseCodeKind Phase = 2;</code>
     */
    public openfmb.commonmodule.Optional_PhaseCodeKind.Builder getPhaseBuilder() {
      bitField0_ |= 0x00000002;
      onChanged();
      return getPhaseFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * Phase code
     * </pre>
     *
     * <code>.commonmodule.Optional_PhaseCodeKind Phase = 2;</code>
     */
    public openfmb.commonmodule.Optional_PhaseCodeKindOrBuilder getPhaseOrBuilder() {
      if (phaseBuilder_ != null) {
        return phaseBuilder_.getMessageOrBuilder();
      } else {
        return phase_ == null ?
            openfmb.commonmodule.Optional_PhaseCodeKind.getDefaultInstance() : phase_;
      }
    }
    /**
     * <pre>
     * Phase code
     * </pre>
     *
     * <code>.commonmodule.Optional_PhaseCodeKind Phase = 2;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.Optional_PhaseCodeKind, openfmb.commonmodule.Optional_PhaseCodeKind.Builder, openfmb.commonmodule.Optional_PhaseCodeKindOrBuilder> 
        getPhaseFieldBuilder() {
      if (phaseBuilder_ == null) {
        phaseBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.Optional_PhaseCodeKind, openfmb.commonmodule.Optional_PhaseCodeKind.Builder, openfmb.commonmodule.Optional_PhaseCodeKindOrBuilder>(
                getPhase(),
                getParentForChildren(),
                isClean());
        phase_ = null;
      }
      return phaseBuilder_;
    }

    private openfmb.commonmodule.ControlSPC sPCSO_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.ControlSPC, openfmb.commonmodule.ControlSPC.Builder, openfmb.commonmodule.ControlSPCOrBuilder> sPCSOBuilder_;
    /**
     * <pre>
     * (controllable) If true, generic single point controllable status output &lt;i&gt;n&lt;/i&gt; has been
     * enabled, otherwise it has been disabled.
     * </pre>
     *
     * <code>.commonmodule.ControlSPC SPCSO = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return Whether the sPCSO field is set.
     */
    public boolean hasSPCSO() {
      return ((bitField0_ & 0x00000004) != 0);
    }
    /**
     * <pre>
     * (controllable) If true, generic single point controllable status output &lt;i&gt;n&lt;/i&gt; has been
     * enabled, otherwise it has been disabled.
     * </pre>
     *
     * <code>.commonmodule.ControlSPC SPCSO = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return The sPCSO.
     */
    public openfmb.commonmodule.ControlSPC getSPCSO() {
      if (sPCSOBuilder_ == null) {
        return sPCSO_ == null ? openfmb.commonmodule.ControlSPC.getDefaultInstance() : sPCSO_;
      } else {
        return sPCSOBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * (controllable) If true, generic single point controllable status output &lt;i&gt;n&lt;/i&gt; has been
     * enabled, otherwise it has been disabled.
     * </pre>
     *
     * <code>.commonmodule.ControlSPC SPCSO = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setSPCSO(openfmb.commonmodule.ControlSPC value) {
      if (sPCSOBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        sPCSO_ = value;
      } else {
        sPCSOBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * (controllable) If true, generic single point controllable status output &lt;i&gt;n&lt;/i&gt; has been
     * enabled, otherwise it has been disabled.
     * </pre>
     *
     * <code>.commonmodule.ControlSPC SPCSO = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setSPCSO(
        openfmb.commonmodule.ControlSPC.Builder builderForValue) {
      if (sPCSOBuilder_ == null) {
        sPCSO_ = builderForValue.build();
      } else {
        sPCSOBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * (controllable) If true, generic single point controllable status output &lt;i&gt;n&lt;/i&gt; has been
     * enabled, otherwise it has been disabled.
     * </pre>
     *
     * <code>.commonmodule.ControlSPC SPCSO = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder mergeSPCSO(openfmb.commonmodule.ControlSPC value) {
      if (sPCSOBuilder_ == null) {
        if (((bitField0_ & 0x00000004) != 0) &&
          sPCSO_ != null &&
          sPCSO_ != openfmb.commonmodule.ControlSPC.getDefaultInstance()) {
          getSPCSOBuilder().mergeFrom(value);
        } else {
          sPCSO_ = value;
        }
      } else {
        sPCSOBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * (controllable) If true, generic single point controllable status output &lt;i&gt;n&lt;/i&gt; has been
     * enabled, otherwise it has been disabled.
     * </pre>
     *
     * <code>.commonmodule.ControlSPC SPCSO = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder clearSPCSO() {
      bitField0_ = (bitField0_ & ~0x00000004);
      sPCSO_ = null;
      if (sPCSOBuilder_ != null) {
        sPCSOBuilder_.dispose();
        sPCSOBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * (controllable) If true, generic single point controllable status output &lt;i&gt;n&lt;/i&gt; has been
     * enabled, otherwise it has been disabled.
     * </pre>
     *
     * <code>.commonmodule.ControlSPC SPCSO = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.commonmodule.ControlSPC.Builder getSPCSOBuilder() {
      bitField0_ |= 0x00000004;
      onChanged();
      return getSPCSOFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * (controllable) If true, generic single point controllable status output &lt;i&gt;n&lt;/i&gt; has been
     * enabled, otherwise it has been disabled.
     * </pre>
     *
     * <code>.commonmodule.ControlSPC SPCSO = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.commonmodule.ControlSPCOrBuilder getSPCSOOrBuilder() {
      if (sPCSOBuilder_ != null) {
        return sPCSOBuilder_.getMessageOrBuilder();
      } else {
        return sPCSO_ == null ?
            openfmb.commonmodule.ControlSPC.getDefaultInstance() : sPCSO_;
      }
    }
    /**
     * <pre>
     * (controllable) If true, generic single point controllable status output &lt;i&gt;n&lt;/i&gt; has been
     * enabled, otherwise it has been disabled.
     * </pre>
     *
     * <code>.commonmodule.ControlSPC SPCSO = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.ControlSPC, openfmb.commonmodule.ControlSPC.Builder, openfmb.commonmodule.ControlSPCOrBuilder> 
        getSPCSOFieldBuilder() {
      if (sPCSOBuilder_ == null) {
        sPCSOBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.ControlSPC, openfmb.commonmodule.ControlSPC.Builder, openfmb.commonmodule.ControlSPCOrBuilder>(
                getSPCSO(),
                getParentForChildren(),
                isClean());
        sPCSO_ = null;
      }
      return sPCSOBuilder_;
    }
    @java.lang.Override
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:resourcemodule.BooleanControlGGIO)
  }

  // @@protoc_insertion_point(class_scope:resourcemodule.BooleanControlGGIO)
  private static final openfmb.resourcemodule.BooleanControlGGIO DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new openfmb.resourcemodule.BooleanControlGGIO();
  }

  public static openfmb.resourcemodule.BooleanControlGGIO getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<BooleanControlGGIO>
      PARSER = new com.google.protobuf.AbstractParser<BooleanControlGGIO>() {
    @java.lang.Override
    public BooleanControlGGIO parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      Builder builder = newBuilder();
      try {
        builder.mergeFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(builder.buildPartial());
      } catch (com.google.protobuf.UninitializedMessageException e) {
        throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(e)
            .setUnfinishedMessage(builder.buildPartial());
      }
      return builder.buildPartial();
    }
  };

  public static com.google.protobuf.Parser<BooleanControlGGIO> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<BooleanControlGGIO> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public openfmb.resourcemodule.BooleanControlGGIO getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

